---
title: Converting WebAssembly text format to wasm
slug: WebAssembly/Text_format_to_wasm
tags:
  - WebAssembly
  - assembly
  - conversion
  - text format
  - wabt
  - wasm
  - wast2wasm
  - wat2wasm
---
<p>{{WebAssemblySidebar}}</p>

<p class="summary">WebAssembly has an S-expression-based textual representation, an intermediate form designed to be exposed in text editors, browser developer tools, etc. This article explains a little bit about how it works, and how to use available tools to convert text format files to the <code>.wasm</code> assembly format.</p>

<div class="notecard note">
<p><strong>Note</strong>: Text format files are usually saved with a <code>.wat</code> extension. Historically, a <code>.wast</code> extension was also used, however that's now used for the scripting language used by the WebAssembly testsuite.</p>
</div>

<h2 id="A_first_look_at_the_text_format">A first look at the text format</h2>

<p>Let’s look at a simple example of this — the following program imports a function called <code>imported_func</code> from a module called <code>imports</code>, and exports a function called <code>exported_func</code>:</p>

<pre class="brush: wasm; notranslate">(module
  (func $i (import "imports" "imported_func") (param i32))
  (func (export "exported_func")
    i32.const 42
    call $i
  )
)</pre>

<p>The WebAssembly function <code>exported_func</code> is exported for use in our environment (e.g. the web app in which we are using our WebAssembly module). When it is called, it calls an imported JavaScript function called <code>imported_func</code>, which is run with the value (42) provided as a parameter.</p>

<h2 id="Converting_the_text_.wat_into_a_binary_.wasm_file">Converting the text .wat into a binary .wasm file</h2>

<p>Let’s have a go at converting the above <code>.wat</code> text representation example into <code>.wasm </code>assembly format.</p>

<ol>
 <li>To start with, make a copy of the above listing inside a text file; call it <code>simple.wat</code>.</li>
 <li>We need to assemble this textual representation into the assembly language the browser actually reads before we can use it. To do this, we can use the wabt tool, which includes compilers to convert between WebAssembly’s text representation and wasm, and vice versa, plus more besides. Go to <a href="https://github.com/webassembly/wabt">https://github.com/webassembly/wabt</a> — follow the instructions on this page to set up the tool.</li>
 <li>Once you’ve got the tool built, add the <code>/wabt/out/clang/Debug</code> directory to your system <code>PATH</code>.</li>
 <li>Next, execute the wat2wasm program, passing it the path to the input file, followed by an <code>-o</code> parameter, followed by the path to the output file:
  <pre class="brush: bash; no-line-numbers notranslate">wat2wasm simple.wat -o simple.wasm</pre>
 </li>
</ol>

<p>This will convert the wasm into a file called <code>simple.wasm</code>, which contains the <code>.wasm</code> assembly code.</p>

<div class="notecard note">
<p><strong>Note</strong>: You can also convert the assembly back into the text representation using the wasm2wat tool; for example <code>wasm2wat simple.wasm -o text.wat</code>.</p>
</div>

<h2 id="Viewing_the_assembly_output">Viewing the assembly output</h2>

<p>Because the output file is assembly-based, it can’t be viewed in a normal text editor. However, you can view it using the wat2wasm tool’s <code>-v</code> option. Try this:</p>

<pre class="brush: bash; no-line-numbers notranslate">wat2wasm simple.wat -v</pre>

<p>This will give you an output in your terminal in the following way:</p>

<p><img alt="several strings of binary with textual descriptions beside them. For example: 0000008: 01 ; section code " src="https://mdn.mozillademos.org/files/14653/assembly-output.png" style="display: block; margin: 0px auto;"></p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/WebAssembly/Understanding_the_text_format">Understanding WebAssembly text format</a> — a detailed explanation of the text format syntax.</li>
 <li><a href="/en-US/docs/WebAssembly/C_to_wasm">Compiling from C/C++ to WebAssembly</a> — tools like Binaryen/Emscripten both compile your source code to wasm, and create the API code needed to run the module in a JavaScript context. Find out more about how to use them.</li>
 <li><a href="/en-US/docs/WebAssembly/Using_the_JavaScript_API">Using the WebAssembly JavaScript API</a> — read this if you want to find out more about how the WebAssembly API code works.</li>
 <li><a href="https://webassembly.github.io/spec/core/text/index.html">Text format</a> — more explanation of the text format, on the WebAssembly GitHub repo.</li>
 <li><a href="https://github.com/xtuc/webassemblyjs/tree/master/packages/wast-loader">wast-loader</a> — a loader for WebPack that takes care of all of this for you.</li>
</ul>
